Delegate selected proxy integrations to an exe.dev VM or Fly.io Machine
curl --request POST \
--url https://app.factorize.sh/api/v1/agent/vm-grants \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"providerIntegrationId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"vm": "<string>",
"integrationIds": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"idempotencyKey": "<string>",
"app": "<string>"
}
'import requests
url = "https://app.factorize.sh/api/v1/agent/vm-grants"
payload = {
"providerIntegrationId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"vm": "<string>",
"integrationIds": ["3c90c3cc-0d44-4b50-8888-8dd25736052a"],
"idempotencyKey": "<string>",
"app": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
providerIntegrationId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
vm: '<string>',
integrationIds: ['3c90c3cc-0d44-4b50-8888-8dd25736052a'],
idempotencyKey: '<string>',
app: '<string>'
})
};
fetch('https://app.factorize.sh/api/v1/agent/vm-grants', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://app.factorize.sh/api/v1/agent/vm-grants",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'providerIntegrationId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'vm' => '<string>',
'integrationIds' => [
'3c90c3cc-0d44-4b50-8888-8dd25736052a'
],
'idempotencyKey' => '<string>',
'app' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://app.factorize.sh/api/v1/agent/vm-grants"
payload := strings.NewReader("{\n \"providerIntegrationId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"vm\": \"<string>\",\n \"integrationIds\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"idempotencyKey\": \"<string>\",\n \"app\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://app.factorize.sh/api/v1/agent/vm-grants")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"providerIntegrationId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"vm\": \"<string>\",\n \"integrationIds\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"idempotencyKey\": \"<string>\",\n \"app\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://app.factorize.sh/api/v1/agent/vm-grants")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"providerIntegrationId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"vm\": \"<string>\",\n \"integrationIds\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"idempotencyKey\": \"<string>\",\n \"app\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"grantId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"vm": "<string>",
"integrationIds": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"expiresAt": "<string>",
"tokenUrl": "<string>",
"proofFile": "<string>",
"requestUrl": "<string>",
"instructions": "<string>",
"provider": "exe.dev",
"app": "<string>",
"audience": "<string>",
"tokenSocket": "<string>",
"readResponseUrl": "<string>"
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}agent
Delegate selected proxy integrations to an exe.dev VM or Fly.io Machine
Requires an OAuth agent with proxy:use, vm:grant and access to the provider and each selected integration. Fly.io requires app plus the Machine ID as vm; exe.dev uses the VM name. Lasts one hour; explicit renewal is required to extend access.
Requires the vm:grant and proxy:use scopes.
Accepts a scoped bearer token, vendor-verified run identity, or interactive owner session.
POST
/
api
/
v1
/
agent
/
vm-grants
Delegate selected proxy integrations to an exe.dev VM or Fly.io Machine
curl --request POST \
--url https://app.factorize.sh/api/v1/agent/vm-grants \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"providerIntegrationId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"vm": "<string>",
"integrationIds": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"idempotencyKey": "<string>",
"app": "<string>"
}
'import requests
url = "https://app.factorize.sh/api/v1/agent/vm-grants"
payload = {
"providerIntegrationId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"vm": "<string>",
"integrationIds": ["3c90c3cc-0d44-4b50-8888-8dd25736052a"],
"idempotencyKey": "<string>",
"app": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
providerIntegrationId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
vm: '<string>',
integrationIds: ['3c90c3cc-0d44-4b50-8888-8dd25736052a'],
idempotencyKey: '<string>',
app: '<string>'
})
};
fetch('https://app.factorize.sh/api/v1/agent/vm-grants', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://app.factorize.sh/api/v1/agent/vm-grants",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'providerIntegrationId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'vm' => '<string>',
'integrationIds' => [
'3c90c3cc-0d44-4b50-8888-8dd25736052a'
],
'idempotencyKey' => '<string>',
'app' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://app.factorize.sh/api/v1/agent/vm-grants"
payload := strings.NewReader("{\n \"providerIntegrationId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"vm\": \"<string>\",\n \"integrationIds\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"idempotencyKey\": \"<string>\",\n \"app\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://app.factorize.sh/api/v1/agent/vm-grants")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"providerIntegrationId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"vm\": \"<string>\",\n \"integrationIds\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"idempotencyKey\": \"<string>\",\n \"app\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://app.factorize.sh/api/v1/agent/vm-grants")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"providerIntegrationId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"vm\": \"<string>\",\n \"integrationIds\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"idempotencyKey\": \"<string>\",\n \"app\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"grantId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"vm": "<string>",
"integrationIds": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"expiresAt": "<string>",
"tokenUrl": "<string>",
"proofFile": "<string>",
"requestUrl": "<string>",
"instructions": "<string>",
"provider": "exe.dev",
"app": "<string>",
"audience": "<string>",
"tokenSocket": "<string>",
"readResponseUrl": "<string>"
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>"
}
}Authorizations
bearerAuthvendorRunIdentity & runIdentityHeadercookieAuth
Body
application/json
Response
Verified VM grant